import 'package:cl_datahub_common/common.dart';

import 'api_response.dart';
import 'utils.dart';

class StatusCodeException extends ApiException {
  final Uri? endpointUrl;
  final int statusCode;
  final String status;

  StatusCodeException(this.endpointUrl, this.statusCode)
      : status = getHttpStatus(statusCode),
        super(getHttpStatus(statusCode));

  factory StatusCodeException.fromResponse(ApiResponse response) =>
      StatusCodeException(response.requestUrl, response.statusCode);

  @override
  String toString() => '$endpointUrl: $status ($statusCode)';
}
