import 'package:cl_appbase/bloc.dart';

abstract class CollectionController<Item> {
  final Collection<Item> collection;

  Stream<PropertyState<CollectionStateModel>> get stream;

  CollectionController(this.collection);

  /// Invalidates caches and implies that data should be
  /// re-fetched while trying to keep the current collection state
  /// (f.e. page offset and size in [PagedCollectionController]).
  Future<void> invalidate();

  void dispose();
}
