import 'package:cl_appbase/appbase.dart';

class Comment extends IntIdTransferObject {
  static Comment factory(data) => Comment(data);

  static const postIdField = IntField('postId');
  static const nameField = StrField('name');
  static const emailField = StrField('email');
  static const bodyField = StrField('body');

  static const fields = <Field>[postIdField, nameField, emailField, bodyField];

  Comment(Map<String, dynamic> data) : super(fields, data);
  Comment.create(Map<Field, dynamic> data) : super.create(data);

  int? get postId => get(postIdField);
  String? get name => get(nameField);
  String? get email => get(emailField);
  String? get body => get(bodyField);

  @override
  String toString() {
    return 'id: $id\name: $name\nbody: $body\npostId: $postId';
  }
}
