import 'package:cl_appbase/appbase.dart';

class Post extends IntIdTransferObject {
  static Post factory(data) => Post(data);

  static const titleField = StrField('title');
  static const bodyField = StrField('body');
  static const userIdField = IntField('userId');

  static const fields = <Field>[titleField, bodyField, userIdField];

  Post(Map<String, dynamic> data) : super(fields, data);

  Post.create({int? id, String? title, String? body, int? userId})
      : super.create({
          IntIdTransferObject.idField: id,
          titleField: title,
          bodyField: body,
          userIdField: userId
        });

  String? get title => get(titleField);
  String? get body => get(bodyField);
  int? get userId => get(userIdField);

  @override
  String toString() {
    return 'id: $id\ntitle: $title\nbody: $body\nuserId: $userId';
  }
}
